""" Very simple client implementation to use ETI TAXII server for Python3 using taxii2-client package::
    pip install taxii2-client

To run this script, you need to generate Taxii token via ETI portal https://preview-eti.eset.com/ and set username and password variables below

"""

import datetime
from datetime import timedelta

# 3rd party packages
from taxii2client.v21 import Server, as_pages

username = 'enter username here'
password = 'enter password here'


def main():
    """ Download all available packages from last 2 hours and print them.
    """
    server = Server('https://taxii.eset.com/taxii2/', user=username, password=password)

    print(server.title)

    api_root = server.api_roots[0]

    #set date variable 2 hours back
    date = datetime.datetime.now() - timedelta(hours=2)

    #iterate through the available collections and print new items
    for collection in api_root.collections:

        print(collection.title)

        # no pagination request
        print(collection.get_objects(added_after=date))

        # pagination request.
        for envelope in as_pages(collection.get_objects, per_request=50, added_after=date):
            print(envelope)

if __name__ == "__main__":
    main()
